
// Preprocessor
#property copyright "Andrew Young"
#include <IncludeExample.mqh>

extern int     NumberOfBars = 5000 ; // 0 ; 500;
extern string  Note = "0 means Display all bars";
extern int     MAPeriod = 100 ;
extern int     LookBack = 10;
extern int     width1 = 2 ;
extern int     width2 = 2 ;


// External variables
extern bool DynamicLotSize = true;
extern double EquityPercent = 2;
extern double FixedLotSize = 0.1;
extern double StopLoss = 50;
extern double TakeProfit = 100;
extern int TrailingStop = 50;
extern int MinimumProfit = 50;
extern int Slippage = 5;
extern int MagicNumber = 123;
extern bool CheckOncePerBar = true;



// Global variables
int BuyTicket;
int SellTicket;
double UsePoint;
int UseSlippage;
datetime CurrentTimeStamp;


// Init function
int init()
   {
   UsePoint = PipPoint(Symbol());
   UseSlippage = GetSlippage(Symbol(),Slippage);
}


// Start function
int start()
{

// Execute on bar open
   if(CheckOncePerBar == true)
   {
      int BarShift = 1;
      if(CurrentTimeStamp != Time[0])
   {
      CurrentTimeStamp = Time[0];
      bool NewBar = true;
   }
   else NewBar = false;
   }
   else
   {
      NewBar = true;
      BarShift = 0;
   }


// Indicator Buffers

iCustom(Symbol(),Period(),"vol",NumberOfBars,Note,MAPeriod,LookBack,width1,width2,0,0);
double up = iCustom(Symbol(), Period(), "vol",NumberOfBars,Note,MAPeriod,LookBack,width1,width2, 0, 1);
double down = iCustom(Symbol(), Period(), "vol",NumberOfBars,Note,MAPeriod,LookBack,width1,width2, 4, 1);

// Calculate lot size
   double LotSize = CalcLotSize(DynamicLotSize,EquityPercent,StopLoss,FixedLotSize);
   LotSize = VerifyLotSize(LotSize);

// Begin trade block
   if(NewBar == true)
   {
// Buy order
   if(up > 0 && BuyMarketCount(Symbol(),MagicNumber) == 0)
   {
   printf("up = %.1f down = %.1f",up,down);
// Close sell orders
   if(SellMarketCount(Symbol(),MagicNumber) > 0)
   {
      CloseAllSellOrders(Symbol(),MagicNumber,Slippage);
   }
// Open buy order
   BuyTicket = OpenBuyOrder(Symbol(),LotSize,UseSlippage,MagicNumber);

// Order modification
   if(BuyTicket > 0 && (StopLoss > 0 || TakeProfit > 0))
   {
      OrderSelect(BuyTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice();

// Calculate and verify stop loss and take profit
      double BuyStopLoss = CalcBuyStopLoss(Symbol(),StopLoss,OpenPrice);
   if(BuyStopLoss > 0) BuyStopLoss = AdjustBelowStopLevel(Symbol(), BuyStopLoss,5);
      double BuyTakeProfit = CalcBuyTakeProfit(Symbol(),TakeProfit,OpenPrice);
   if(BuyTakeProfit > 0) BuyTakeProfit = AdjustAboveStopLevel(Symbol(),BuyTakeProfit,5);

// Add stop loss and take profit
   AddStopProfit(BuyTicket,BuyStopLoss,BuyTakeProfit);
   }
   }






// Sell Order
   if(down > 0 && SellMarketCount(Symbol(),MagicNumber) == 0)
   {
   printf("up = %.1f down = %.1f",up,down);
   if(BuyMarketCount(Symbol(),MagicNumber) > 0)
   {
      CloseAllBuyOrders(Symbol(),MagicNumber,Slippage);
   }
   SellTicket = OpenSellOrder(Symbol(),LotSize,UseSlippage,MagicNumber);
   if(SellTicket > 0 && (StopLoss > 0 || TakeProfit > 0))
   {
      OrderSelect(SellTicket,SELECT_BY_TICKET);
      OpenPrice = OrderOpenPrice();
      double SellStopLoss = CalcSellStopLoss(Symbol(),StopLoss,OpenPrice);
   if(SellStopLoss > 0) SellStopLoss = AdjustAboveStopLevel(Symbol(),SellStopLoss,5);
         double SellTakeProfit = CalcSellTakeProfit(Symbol(),TakeProfit,OpenPrice);
   if(SellTakeProfit > 0) SellTakeProfit = AdjustBelowStopLevel(Symbol(),SellTakeProfit,5);
         AddStopProfit(SellTicket,SellStopLoss,SellTakeProfit);
   }
   }
}// End trade block


// Adjust trailing stops
if(BuyMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
   {
      BuyTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);
   }
   if(SellMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
   {
      SellTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);   
   }
   return(0);
   }













